"admin_required": "role:admin or is_admin:1"
"service_role": "role:service"
"service_or_admin": "rule:admin_required or rule:service_role"
"owner": "user_id:%(user_id)s"
"admin_or_owner": "rule:admin_required or rule:owner"
"token_subject": "user_id:%(target.token.user_id)s"
"admin_or_token_subject": "rule:admin_required or rule:token_subject"
"service_admin_or_token_subject": "rule:service_or_admin or rule:token_subject"
"identity:get_access_rule": "(role:reader and system_scope:all) or user_id:%(target.user.id)s"
"identity:list_access_rules": "(role:reader and system_scope:all) or user_id:%(target.user.id)s"
"identity:delete_access_rule": "(role:admin and system_scope:all) or user_id:%(target.user.id)s"
"identity:authorize_request_token": "rule:admin_required"
"identity:get_access_token": "rule:admin_required"
"identity:get_access_token_role": "rule:admin_required"
"identity:list_access_tokens": "rule:admin_required"
"identity:list_access_token_roles": "rule:admin_required"
"identity:delete_access_token": "rule:admin_required"
"identity:get_application_credential": "(rule:admin_required) or (role:reader and system_scope:all) or rule:owner"
"identity:list_application_credentials": "(rule:admin_required) or (role:reader and system_scope:all) or rule:owner"
"identity:create_application_credential": "user_id:%(user_id)s"
"identity:delete_application_credential": "rule:admin_or_owner"
"identity:get_auth_catalog": ""
"identity:get_auth_projects": ""
"identity:get_auth_domains": ""
"identity:get_auth_system": ""
"identity:get_consumer": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_consumers": "rule:admin_required or (role:reader and system_scope:all)"
"identity:create_consumer": "rule:admin_required"
"identity:update_consumer": "rule:admin_required"
"identity:delete_consumer": "rule:admin_required"
"identity:get_credential": "(rule:admin_required) or (role:reader and system_scope:all) or user_id:%(target.credential.user_id)s"
"identity:list_credentials": "(rule:admin_required) or (role:reader and system_scope:all) or user_id:%(target.credential.user_id)s"
"identity:create_credential": "(rule:admin_required) or user_id:%(target.credential.user_id)s"
"identity:update_credential": "(rule:admin_required) or user_id:%(target.credential.user_id)s"
"identity:delete_credential": "(rule:admin_required) or user_id:%(target.credential.user_id)s"
"identity:get_domain": "rule:admin_required or (role:reader and system_scope:all) or token.domain.id:%(target.domain.id)s or token.project.domain.id:%(target.domain.id)s"
"identity:list_domains": "rule:admin_required or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.domain.id)s)"
"identity:create_domain": "rule:admin_required"
"identity:update_domain": "rule:admin_required"
"identity:delete_domain": "rule:admin_required"
"identity:create_domain_config": "rule:admin_required"
"identity:get_domain_config": "rule:admin_required or (role:reader and system_scope:all)"
"identity:get_security_compliance_domain_config": ""
"identity:update_domain_config": "rule:admin_required"
"identity:delete_domain_config": "rule:admin_required"
"identity:get_domain_config_default": "rule:admin_required or (role:reader and system_scope:all)"
"identity:ec2_get_credential": "(rule:admin_required) or (role:reader and system_scope:all) or user_id:%(target.credential.user_id)s"
"identity:ec2_list_credentials": "(rule:admin_required) or (role:reader and system_scope:all) or rule:owner"
"identity:ec2_create_credential": "rule:admin_or_owner"
"identity:ec2_delete_credential": "(rule:admin_required) or user_id:%(target.credential.user_id)s"
"identity:get_endpoint": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_endpoints": "rule:admin_required or (role:reader and system_scope:all)"
"identity:create_endpoint": "rule:admin_required"
"identity:update_endpoint": "rule:admin_required"
"identity:delete_endpoint": "rule:admin_required"
"identity:create_endpoint_group": "rule:admin_required"
"identity:list_endpoint_groups": "rule:admin_required or (role:reader and system_scope:all)"
"identity:get_endpoint_group": "rule:admin_required or (role:reader and system_scope:all)"
"identity:update_endpoint_group": "rule:admin_required"
"identity:delete_endpoint_group": "rule:admin_required"
"identity:list_projects_associated_with_endpoint_group": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_endpoints_associated_with_endpoint_group": "rule:admin_required or (role:reader and system_scope:all)"
"identity:get_endpoint_group_in_project": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_endpoint_groups_for_project": "rule:admin_required or (role:reader and system_scope:all)"
"identity:add_endpoint_group_to_project": "rule:admin_required"
"identity:remove_endpoint_group_from_project": "rule:admin_required"
"identity:check_grant": "(rule:admin_required) or ((role:reader and system_scope:all) or ((role:reader and domain_id:%(target.user.domain_id)s and domain_id:%(target.project.domain_id)s) or (role:reader and domain_id:%(target.user.domain_id)s and domain_id:%(target.domain.id)s) or (role:reader and domain_id:%(target.group.domain_id)s and domain_id:%(target.project.domain_id)s) or (role:reader and domain_id:%(target.group.domain_id)s and domain_id:%(target.domain.id)s)) and (domain_id:%(target.role.domain_id)s or None:%(target.role.domain_id)s))"
"identity:list_grants": "(rule:admin_required) or ((role:reader and system_scope:all) or (role:reader and domain_id:%(target.user.domain_id)s and domain_id:%(target.project.domain_id)s) or (role:reader and domain_id:%(target.user.domain_id)s and domain_id:%(target.domain.id)s) or (role:reader and domain_id:%(target.group.domain_id)s and domain_id:%(target.project.domain_id)s) or (role:reader and domain_id:%(target.group.domain_id)s and domain_id:%(target.domain.id)s))"
"identity:create_grant": "(rule:admin_required) or ((role:admin and domain_id:%(target.user.domain_id)s and domain_id:%(target.project.domain_id)s) or (role:admin and domain_id:%(target.user.domain_id)s and domain_id:%(target.domain.id)s) or (role:admin and domain_id:%(target.group.domain_id)s and domain_id:%(target.project.domain_id)s) or (role:admin and domain_id:%(target.group.domain_id)s and domain_id:%(target.domain.id)s)) and (domain_id:%(target.role.domain_id)s or None:%(target.role.domain_id)s)"
"identity:revoke_grant": "(rule:admin_required) or ((role:admin and domain_id:%(target.user.domain_id)s and domain_id:%(target.project.domain_id)s) or (role:admin and domain_id:%(target.user.domain_id)s and domain_id:%(target.domain.id)s) or (role:admin and domain_id:%(target.group.domain_id)s and domain_id:%(target.project.domain_id)s) or (role:admin and domain_id:%(target.group.domain_id)s and domain_id:%(target.domain.id)s)) and (domain_id:%(target.role.domain_id)s or None:%(target.role.domain_id)s)"
"identity:list_system_grants_for_user": "rule:admin_required or (role:reader and system_scope:all)"
"identity:check_system_grant_for_user": "rule:admin_required or (role:reader and system_scope:all)"
"identity:create_system_grant_for_user": "rule:admin_required"
"identity:revoke_system_grant_for_user": "rule:admin_required"
"identity:list_system_grants_for_group": "rule:admin_required or (role:reader and system_scope:all)"
"identity:check_system_grant_for_group": "rule:admin_required or (role:reader and system_scope:all)"
"identity:create_system_grant_for_group": "rule:admin_required"
"identity:revoke_system_grant_for_group": "rule:admin_required"
"identity:get_group": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.group.domain_id)s)"
"identity:list_groups": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.group.domain_id)s)"
"identity:list_groups_for_user": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.user.domain_id)s) or user_id:%(user_id)s"
"identity:create_group": "rule:admin_required"
"identity:update_group": "rule:admin_required"
"identity:delete_group": "rule:admin_required"
"identity:list_users_in_group": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.group.domain_id)s)"
"identity:remove_user_from_group": "rule:admin_required"
"identity:check_user_in_group": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.group.domain_id)s and domain_id:%(target.user.domain_id)s)"
"identity:add_user_to_group": "rule:admin_required"
"identity:create_identity_provider": "rule:admin_required"
"identity:list_identity_providers": "rule:admin_required or (role:reader and system_scope:all)"
"identity:get_identity_provider": "rule:admin_required or (role:reader and system_scope:all)"
"identity:update_identity_provider": "rule:admin_required"
"identity:delete_identity_provider": "rule:admin_required"
"identity:get_implied_role": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_implied_roles": "rule:admin_required or (role:reader and system_scope:all)"
"identity:create_implied_role": "rule:admin_required"
"identity:delete_implied_role": "rule:admin_required"
"identity:list_role_inference_rules": "rule:admin_required or (role:reader and system_scope:all)"
"identity:check_implied_role": "rule:admin_required or (role:reader and system_scope:all)"
"identity:get_limit_model": ""
"identity:get_limit": "rule:admin_required or (role:reader and system_scope:all) or (domain_id:%(target.limit.domain.id)s or domain_id:%(target.limit.project.domain_id)s) or (project_id:%(target.limit.project_id)s and not None:%(target.limit.project_id)s)"
"identity:list_limits": ""
"identity:create_limits": "rule:admin_required"
"identity:update_limit": "rule:admin_required"
"identity:delete_limit": "rule:admin_required"
"identity:create_mapping": "rule:admin_required"
"identity:get_mapping": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_mappings": "rule:admin_required or (role:reader and system_scope:all)"
"identity:delete_mapping": "rule:admin_required"
"identity:update_mapping": "rule:admin_required"
"identity:get_policy": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_policies": "rule:admin_required or (role:reader and system_scope:all)"
"identity:create_policy": "rule:admin_required"
"identity:update_policy": "rule:admin_required"
"identity:delete_policy": "rule:admin_required"
"identity:create_policy_association_for_endpoint": "rule:admin_required"
"identity:check_policy_association_for_endpoint": "rule:admin_required or (role:reader and system_scope:all)"
"identity:delete_policy_association_for_endpoint": "rule:admin_required"
"identity:create_policy_association_for_service": "rule:admin_required"
"identity:check_policy_association_for_service": "rule:admin_required or (role:reader and system_scope:all)"
"identity:delete_policy_association_for_service": "rule:admin_required"
"identity:create_policy_association_for_region_and_service": "rule:admin_required"
"identity:check_policy_association_for_region_and_service": "rule:admin_required or (role:reader and system_scope:all)"
"identity:delete_policy_association_for_region_and_service": "rule:admin_required"
"identity:get_policy_for_endpoint": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_endpoints_for_policy": "rule:admin_required or (role:reader and system_scope:all)"
"identity:get_project": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.project.domain_id)s) or project_id:%(target.project.id)s"
"identity:list_projects": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.domain_id)s)"
"identity:list_user_projects": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.user.domain_id)s) or user_id:%(target.user.id)s"
"identity:create_project": "rule:admin_required"
"identity:update_project": "rule:admin_required"
"identity:delete_project": "rule:admin_required"
"identity:list_project_tags": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.project.domain_id)s) or project_id:%(target.project.id)s"
"identity:get_project_tag": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.project.domain_id)s) or project_id:%(target.project.id)s"
"identity:update_project_tags": "rule:admin_required"
"identity:create_project_tag": "rule:admin_required"
"identity:delete_project_tags": "rule:admin_required"
"identity:delete_project_tag": "rule:admin_required"
"identity:list_projects_for_endpoint": "rule:admin_required or (role:reader and system_scope:all)"
"identity:add_endpoint_to_project": "rule:admin_required"
"identity:check_endpoint_in_project": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_endpoints_for_project": "rule:admin_required or (role:reader and system_scope:all)"
"identity:remove_endpoint_from_project": "rule:admin_required"
"identity:create_protocol": "rule:admin_required"
"identity:update_protocol": "rule:admin_required"
"identity:get_protocol": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_protocols": "rule:admin_required or (role:reader and system_scope:all)"
"identity:delete_protocol": "rule:admin_required"
"identity:get_region": ""
"identity:list_regions": ""
"identity:create_region": "rule:admin_required"
"identity:update_region": "rule:admin_required"
"identity:delete_region": "rule:admin_required"
"identity:get_registered_limit": ""
"identity:list_registered_limits": ""
"identity:create_registered_limits": "rule:admin_required"
"identity:update_registered_limit": "rule:admin_required"
"identity:delete_registered_limit": "rule:admin_required"
"identity:list_revoke_events": "rule:service_or_admin"
"identity:get_role": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_roles": "rule:admin_required or (role:reader and system_scope:all)"
"identity:create_role": "rule:admin_required"
"identity:update_role": "rule:admin_required"
"identity:delete_role": "rule:admin_required"
"identity:get_domain_role": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_domain_roles": "rule:admin_required or (role:reader and system_scope:all)"
"identity:create_domain_role": "rule:admin_required"
"identity:update_domain_role": "rule:admin_required"
"identity:delete_domain_role": "rule:admin_required"
"identity:list_role_assignments": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.domain_id)s)"
"identity:list_role_assignments_for_tree": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.domain_id)s)"
"identity:get_service": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_services": "rule:admin_required or (role:reader and system_scope:all)"
"identity:create_service": "rule:admin_required"
"identity:update_service": "rule:admin_required"
"identity:delete_service": "rule:admin_required"
"identity:create_service_provider": "rule:admin_required"
"identity:list_service_providers": "rule:admin_required or (role:reader and system_scope:all)"
"identity:get_service_provider": "rule:admin_required or (role:reader and system_scope:all)"
"identity:update_service_provider": "rule:admin_required"
"identity:delete_service_provider": "rule:admin_required"
"identity:revocation_list": "rule:service_or_admin"
"identity:check_token": "rule:admin_required or (role:reader and system_scope:all) or rule:token_subject"
"identity:validate_token": "rule:admin_required or (role:reader and system_scope:all) or rule:service_role or rule:token_subject"
"identity:revoke_token": "rule:admin_required or rule:token_subject"
"identity:create_trust": "user_id:%(trust.trustor_user_id)s"
"identity:list_trusts": "rule:admin_required or (role:reader and system_scope:all)"
"identity:list_trusts_for_trustor": "(rule:admin_required) or (role:reader and system_scope:all or user_id:%(target.trust.trustor_user_id)s)"
"identity:list_trusts_for_trustee": "(rule:admin_required) or (role:reader and system_scope:all or user_id:%(target.trust.trustee_user_id)s)"
"identity:list_roles_for_trust": "(rule:admin_required) or (role:reader and system_scope:all or user_id:%(target.trust.trustor_user_id)s or user_id:%(target.trust.trustee_user_id)s)"
"identity:get_role_for_trust": "(rule:admin_required) or (role:reader and system_scope:all or user_id:%(target.trust.trustor_user_id)s or user_id:%(target.trust.trustee_user_id)s)"
"identity:delete_trust": "rule:admin_required or user_id:%(target.trust.trustor_user_id)s"
"identity:get_trust": "(rule:admin_required) or (role:reader and system_scope:all or user_id:%(target.trust.trustor_user_id)s or user_id:%(target.trust.trustee_user_id)s)"
"identity:get_user": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and token.domain.id:%(target.user.domain_id)s) or user_id:%(target.user.id)s"
"identity:list_users": "(rule:admin_required) or (role:reader and system_scope:all) or (role:reader and domain_id:%(target.domain_id)s)"
"identity:list_projects_for_user": ""
"identity:list_domains_for_user": ""
"identity:create_user": "rule:admin_required"
"identity:update_user": "rule:admin_required"
"identity:delete_user": "rule:admin_required"
